type: log
paths:
{{ range $i, $path := .paths }}
 - {{$path}}
{{ end }}
exclude_files: [".gz$"]
tags: {{.tags | tojson}}
publisher_pipeline.disable_host: {{ inList .tags "forwarded" }}

json.keys_under_root: false

fields_under_root: true
fields:
  network.transport: tcp
  network.protocol: modbus

processors:
  - rename:
      fields:
        - from: "json"
          to: "zeek.modbus"

        - from: "zeek.modbus.id.orig_h"
          to: "source.address"

        - from: "zeek.modbus.id.orig_p"
          to: "source.port"

        - from: "zeek.modbus.id.resp_h"
          to: "destination.address"

        - from: "zeek.modbus.id.resp_p"
          to: "destination.port"

        - from: "zeek.modbus.uid"
          to: "zeek.session_id"

        - from: "zeek.modbus.func"
          to: "zeek.modbus.function"

      ignore_missing: true
      fail_on_error: false
  - convert:
      fields:
        - {from: "zeek.session_id", to: "event.id"}
        - {from: "source.address", to: "source.ip", type: "ip"}
        - {from: "destination.address", to: "destination.ip", type: "ip"}
        - {from: "zeek.modbus.function", to: "event.action"}
      ignore_missing: true
      fail_on_error: false
  - add_fields:
      target: event
      fields:
        kind: event
        category:
          - network
        type:
          - connection
          - protocol
  - if:
      has_fields: ['zeek.modbus.exception']
    then:
      - add_fields:
          target: event
          fields:
            outcome: failure
    else:
      - add_fields:
          target: event
          fields:
            outcome: success
  - community_id:
  - add_fields:
      target: ''
      fields:
        ecs.version: 1.5.0
